力扣题215数组中的第K个最大元素

给定整数数组 nums 和整数 k,请返回数组中第 k 个最大的元素。

请注意,你需要找的是数组排序后的第 k 个最大的元素,而不是第 k 个不同的元素。

示例 1:

输入: [3,2,1,5,6,4] 和 k = 2
输出: 5
示例 2:

输入: [3,2,3,1,2,4,5,5,6] 和 k = 4
输出: 4

1.快速排序。并且只要找到第k大的数字就可以退出递归了。

class Solution {
    // 使用快速排序算法
    
    public int findKthLargest(int[] nums, int k) {
        quickSort(nums,0,nums.length - 1,k);
        return nums[k-1];
    }

    public void quickSort(int[] nums,int left ,int right,int k){
        if (left < right) {
            int l = left;
            int r = right;
            int currentValue = nums[l];
            while (l < r) {
                while (l < r && nums[r] < currentValue) { //从右向左找第一个小于当前值的数
                    r--;
                }

                if (l < r) {//把大的换到前面,小的换到后面
                    nums[l] = nums[r];
                    l++;
                }

                while (l < r && nums[l] > currentValue) { //从左向右找第一个小于当前值的数
                    l++;
                }

                if(l < r){//把大的换到前面,小的换到后面
                    nums[r] = nums[l];
                    r--;
                }
            }
            nums[l] = currentValue;
            if (l == k-1) { //已经找到了第K大的数字,直接返回,不用再排序子列了
                return;
            } else if (l < k - 1){ //如果当前小标小于k-1,说明在右侧,继续递归右子数组
                quickSort(nums,l + 1,right,k);
            } else { //在左侧子数组,继续递归左子数组
                quickSort(nums,left,l - 1,k);
            }
        }
    }
}

   快排可以进行优化:自己的快排就是每次选的都是数组的第一个数字作为当前要排的值,可以对当前值进行随机化。使用随机化可以加快很多。

class Solution {
    // 使用快速排序算法
    
    public int findKthLargest(int[] nums, int k) {
        quickSort(nums,0,nums.length - 1,k);
        return nums[k-1];
    }

    public void quickSort(int[] nums,int left ,int right,int k){
        if (left < right) {
            int l = left;
            int r = right;

            int random=new Random().nextInt(r - l + 1) + l;
            swap(nums,l,random);//随机快排

            int currentValue = nums[l];
            while (l < r) {
                while (l < r && nums[r] < currentValue) { //从右向左找第一个小于当前值的数
                    r--;
                }

                if (l < r) {//把大的换到前面,小的换到后面
                    nums[l] = nums[r];
                    l++;
                }

                while (l < r && nums[l] > currentValue) { //从左向右找第一个小于当前值的数
                    l++;
                }

                if(l < r){//把大的换到前面,小的换到后面
                    nums[r] = nums[l];
                    r--;
                }
            }
            nums[l] = currentValue;
            if (l == k-1) { //已经找到了第K大的数字,直接返回,不用再排序子列了
                return;
            } else if (l < k - 1){ //如果当前小标小于k-1,说明在右侧,继续递归右子数组
                quickSort(nums,l + 1,right,k);
            } else { //在左侧子数组,继续递归左子数组
                quickSort(nums,left,l - 1,k);
            }
        }    
    }

    public void swap(int[] nums,int i,int j){
        int temp=nums[i];
        nums[i]=nums[j];
        nums[j]=temp;
    }
}

2.推排序。这个也一定要会。建立一个大根堆,做k-1次删除操作后堆顶元素就是我们要找的答案。参考:图解排序算法(三)之堆排序 - dreamcatcher-cx - 博客园

class Solution {
    // 使用堆排序算法
    
    public int findKthLargest(int[] nums, int k) {
        int heapSize = nums.length;
        buildMaxHeap(nums,heapSize);   
        for (int i = nums.length - 1; i >= nums.length - k + 1; --i) {
            swap(nums, 0, i);//把当前的最大值放到最右边
            --heapSize;//将堆长度减1,相当于删除了前面移除的最大值
            maxHeapify(nums, 0, heapSize);//调整最大堆
        }
        return nums[0]; //删除k个元素后的堆顶元素就是最大值
    }

    public void buildMaxHeap(int[] nums,int heapSize){
        for(int i = heapSize/2;i >= 0;i--){
            maxHeapify(nums,i,heapSize);
        }
    }

    public void maxHeapify(int[] nums,int i,int heapSize){
        int l = i*2 + 1;//左侧子节点
        int r = i*2 + 2;//右侧子节点
        int largest = i;//最大值下标

        //比较左中右三个节点,找出最大值,将最大值排在中间。
        if(l < heapSize && nums[l] > nums[largest]){
            largest = l;
        }

        if(r < heapSize && nums[r] > nums[largest]){
            largest = r;
        }

        //交换最大值的位置
        if(largest != i){
            swap(nums,i,largest);
            //继续向后递归找到每个左中右的最大值
            maxHeapify(nums,largest,heapSize);
        }
    }

    public void swap(int[] nums,int i,int j){
        int temp=nums[i];
        nums[i]=nums[j];
        nums[j]=temp;
    }
}

题源:力扣

  • 0
    点赞
  • 2
    收藏
    觉得还不错? 一键收藏
  • 0
    评论
问您需要的是两个数组的交集元素还是交集元素的数量? 如果是交集元素,可以采用双指针的方式,先将两个数组排序,然后设定两个指针 i 和 j,分别指向两个数组的开头,比较两个指针所指向的元素的大小,如果相等,则说明到了一个交集元素,将其存到结果数组中;如果不相等,则将指向小的元素的指针向后移动一位,直到其中一个指针越界为止。 代码实现如下: ```c int* intersect(int* nums1, int nums1Size, int* nums2, int nums2Size, int* returnSize){ int i = 0, j = 0, k = 0; int* res = (int*)malloc(sizeof(int) * (nums1Size > nums2Size ? nums2Size : nums1Size)); // 排序 qsort(nums1, nums1Size, sizeof(int), cmp); qsort(nums2, nums2Size, sizeof(int), cmp); while (i < nums1Size && j < nums2Size) { if (nums1[i] == nums2[j]) { res[k++] = nums1[i]; i++; j++; } else if (nums1[i] < nums2[j]) { i++; } else { j++; } } *returnSize = k; return res; } int cmp(const void* a, const void* b) { return *(int*)a - *(int*)b; } ``` 如果是交集元素的数量,可以采用哈希表的方式,用一个哈希表来记录第一个数组中元素出现的次数,然后遍历第二个数组,在哈希表中查是否存在相同的元素,如果存在,则说明到了一个交集元素,将其计数并从哈希表中删除该元素,最后返回计数结果即可。 代码实现如下: ```c int* intersect(int* nums1, int nums1Size, int* nums2, int nums2Size, int* returnSize){ int i = 0, j = 0, k = 0; int* res = (int*)malloc(sizeof(int) * (nums1Size > nums2Size ? nums2Size : nums1Size)); int* hash = (int*)malloc(sizeof(int) * 1001); // 由于目条件限制在 [0, 1000] 范围内,所以哈希表可以开得比较小 memset(hash, 0, sizeof(hash)); for (i = 0; i < nums1Size; i++) { hash[nums1[i]]++; } for (j = 0; j < nums2Size; j++) { if (hash[nums2[j]] > 0) { res[k++] = nums2[j]; hash[nums2[j]]--; } } *returnSize = k; return res; } ``` 希望这些代码能够帮到您,如有疑问随时问我~
评论
添加红包

请填写红包祝福语或标题

红包个数最小为10个

红包金额最低5元

当前余额3.43前往充值 >
需支付:10.00
成就一亿技术人!
领取后你会自动成为博主和红包主的粉丝 规则
hope_wisdom
发出的红包
实付
使用余额支付
点击重新获取
扫码支付
钱包余额 0

抵扣说明:

1.余额是钱包充值的虚拟货币,按照1:1的比例进行支付金额的抵扣。
2.余额无法直接购买下载,可以购买VIP、付费专栏及课程。

余额充值